package de.unikoblenz.fgbks.base.utils.boundary.checker;

import de.unikoblenz.fgbks.base.utils.boundary.AbstractGrowingBoundary;

public class CheckOverlap extends AbstractBoundaryCheck<AbstractGrowingBoundary> {

  private static final CheckOverlap instance = new CheckOverlap();

  private CheckOverlap() {
    super();
  }

  public static CheckOverlap getInstance() {
    return instance;
  }

  @Override
  public BoundaryCheckType getType() {
    return BoundaryCheckType.IS_OVERLAPPING;
  }

  @Override
  public boolean check(AbstractGrowingBoundary b1, AbstractGrowingBoundary b2) {
    return checkOverlapping(b1, b2);
  }

  public static boolean checkOverlapping(AbstractGrowingBoundary b1, AbstractGrowingBoundary b2) {
    return CheckInContact.checkInContact(b1, b2)
        && !CheckEqual.checkEqual(b1, b2)
        && !CheckIsSubsumes.checkIsSubsumption(b1, b2);
  }
}
